Index: LMDZ6/trunk/libf/misc/readTracFiles_mod.f90
===================================================================
--- LMDZ6/trunk/libf/misc/readTracFiles_mod.f90	(revision 5184)
+++ LMDZ6/trunk/libf/misc/readTracFiles_mod.f90	(revision 5190)
@@ -764,8 +807,8 @@
 !  tr2 is introduced in order to cope with a bug in gfortran 4.8.5 compiler
 !------------------------------------------------------------------------------------------------------------------------------
-  lerr = getKey('iGeneration', iGen, tr); IF(lerr) RETURN            !--- Generation number
+  lerr = getKey('iGeneration', iGen, tr%keys); IF(lerr) RETURN       !--- Generation number
   nq = SIZE(tr)
   DO ip = nphases, 1, -1
-    lerr = getKey('name',     tname, tr); IF(lerr) RETURN            !--- Names of the tracers of first generation
+    lerr = getKey('name',     tname, tr%keys); IF(lerr) RETURN       !--- Names of the tracers of first generation
     iq = strIdx(tname, addPhase('H2O', ip))
     IF(iq == 0) CYCLE
@@ -783,5 +826,5 @@
     END DO
   ELSE
-    lerr = getKey('gen0Name', gen0N, tr); IF(lerr) RETURN            !--- Names of the tracers    iq = 1
+    lerr = getKey('gen0Name',   gen0N, tr%keys); IF(lerr) RETURN     !--- Names of the tracers    iq = 1
     DO jq = 1, nq                                                    !--- Loop on generation 0 tracers
       IF(iGen(jq) /= 0) CYCLE                                        !--- Skip generations /= 0
@@ -805,6 +848,7 @@
 LOGICAL FUNCTION mergeTracers(sections, tr) RESULT(lerr)
   TYPE(dataBase_type),  TARGET, INTENT(IN)  :: sections(:)
-  TYPE(keys_type), ALLOCATABLE, INTENT(OUT) ::       tr(:)
-  TYPE(keys_type), POINTER ::   t1(:),   t2(:)
+  TYPE(trac_type), ALLOCATABLE, INTENT(OUT) ::       tr(:)
+  TYPE(trac_type), POINTER ::   t1(:),   t2(:)
+  TYPE(keys_type), POINTER ::   k1(:),   k2(:)
   INTEGER,     ALLOCATABLE :: ixct(:), ixck(:)
   INTEGER :: is, ik, ik1, ik2, nk2, i1, i2, nt2
@@ -814,6 +858,6 @@
   lerr = .FALSE.
   keys = ['parent     ', 'type       ', 'iGeneration']               !--- Mandatory keys
-  t1 => sections(1)%trac(:)                                          !--- Alias: first tracers section
-  lerr = getKey('name', n1, t1); IF(lerr) RETURN                     !--- Names of the tracers
+  t1 => sections(1)%trac(:); k1 => t1(:)%keys                        !--- Alias: first tracers section, corresponding keys
+  lerr = getKey('name', n1, k1); IF(lerr) RETURN                     !--- Names of the tracers
   tr = t1
   !----------------------------------------------------------------------------------------------------------------------------
@@ -821,5 +865,6 @@
   !----------------------------------------------------------------------------------------------------------------------------
     t2  => sections(is)%trac(:)                                      !--- Alias: current tracers section
-    lerr = getKey('name', n2, t2); IF(lerr) RETURN                   !--- Names of the tracers
+    k2  => t2(:)%keys
+    lerr = getKey('name', n2, k2); IF(lerr) RETURN                   !--- Names of the tracers
     nt2  = SIZE(t2(:), DIM=1)                                        !--- Number of tracers in section
     ixct = strIdx(n1(:), n2(:))                                      !--- Indexes of common tracers
@@ -829,5 +874,5 @@
     CALL msg(n1(PACK(ixct, MASK = ixct/=0)), modname, nmax=128)      !--- Display duplicates (the 128 first at most)
     !--------------------------------------------------------------------------------------------------------------------------
-    DO i2=1,nt2; tnam = TRIM(n2(i2))                                 !=== LOOP ON COMMON TRACERS
+    DO i2=1,nt2; tnam = TRIM(t2(i2)%name)                            !=== LOOP ON COMMON TRACERS
     !--------------------------------------------------------------------------------------------------------------------------
       i1 = ixct(i2); IF(i1 == 0) CYCLE                               !--- Idx in t1(:) ; skip new tracers
@@ -836,33 +881,34 @@
       s1=' of "'//TRIM(tnam)//'" in "'//TRIM(sections(is)%name)//'" not matching previous value'
       DO ik = 1, SIZE(keys)
-        lerr = getKey(keys(ik), v1, i1, t1)
-        lerr = getKey(keys(ik), v2, i2, t2)
+        lerr = getKey(keys(ik), v1, i1, k1)
+        lerr = getKey(keys(ik), v2, i2, k2)
         lerr = v1 /= v2; IF(fmsg(TRIM(keys(ik))//TRIM(s1), modname, lerr)) RETURN
       END DO
 
-      !=== GET THE INDICES IN tr(i2)%key(:) OF THE KEYS ALSO PRESENT IN tr(i1)%key(:)
-      nk2  =   SIZE(t2(i2)%key(:))                                   !--- Keys number in current section
-      ixck = strIdx(t1(i1)%key(:), t2(i2)%key(:))                    !--- Common keys indexes
-      !--- APPEND THE NEW KEYS PAIRS IN tr(i1)%key(:)
-      tr(i1)%key = [ tr(i1)%key, PACK(tr(i2)%key, MASK = ixck==0)]
-      tr(i1)%val = [ tr(i1)%val, PACK(tr(i2)%val, MASK = ixck==0)]
+      !=== GET THE INDICES IN tr(i2)%keys%key(:) OF THE KEYS ALSO PRESENT IN tr(i1)%keys%key(:)
+      nk2  =   SIZE(k2(i2)%key(:))                                   !--- Keys number in current section
+      ixck = strIdx(k1(i1)%key(:), k2(i2)%key(:))                    !--- Common keys indexes
+      !--- APPEND THE NEW KEYS PAIRS IN tr(i1)%keys%key(:)
+      tr(i1)%keys%key = [ tr(i1)%keys%key, PACK(tr(i2)%keys%key, MASK = ixck==0)]
+      tr(i1)%keys%val = [ tr(i1)%keys%val, PACK(tr(i2)%keys%val, MASK = ixck==0)]
 
       !=== KEEP TRACK OF THE COMPONENTS NAMES: COMA-SEPARATED LIST
-      lerr = getKey('component', v1, i1, t1)
-      lerr = getKey('component', v2, i2, t2)
-      CALL addKey('component', TRIM(v1)//','//TRIM(v2), tr(i1))
+      lerr = getKey('component', v1, i1, k1)
+      lerr = getKey('component', v2, i2, k2)
+      tr(i1)%component = TRIM(v1)//','//TRIM(v2)
+      CALL addKey('component', TRIM(v1)//','//TRIM(v2), tr(i1)%keys)
 
       !=== FOR TRACERS COMMON TO PREVIOUS AND CURRENT SECTIONS: CHECK WETHER SOME KEYS HAVE DIFFERENT VALUES ; KEEP OLD ONE
       DO ik2 = 1, nk2                                                !--- Collect the corresponding indices
         ik1 = ixck(ik2); IF(ik1 == 0) CYCLE
-        IF(t1(i1)%val(ik1) == t2(i2)%val(ik2)) ixck(ik2)=0
+        IF(k1(i1)%val(ik1) == k2(i2)%val(ik2)) ixck(ik2)=0
       END DO
       IF(ALL(ixck==0)) CYCLE                                         !--- No identical keys with /=values => nothing to display
       CALL msg('Key(s)'//TRIM(s1), modname)                          !--- Display the  keys with /=values (names list)
       DO ik2 = 1, nk2                                                !--- Loop on keys found in both t1(:) and t2(:)
-        knam = t2(i2)%key(ik2)                                       !--- Name of the current key
+        knam = k2(i2)%key(ik2)                                       !--- Name of the current key
         ik1 = ixck(ik2)                                              !--- Corresponding index in t1(:)
         IF(ik1 == 0) CYCLE                                           !--- New keys are skipped
-        v1 = t1(i1)%val(ik1); v2 = t2(i2)%val(ik2)                   !--- Key values in t1(:) and t2(:)
+        v1 = k1(i1)%val(ik1); v2 = k2(i2)%val(ik2)                   !--- Key values in t1(:) and t2(:)
         CALL msg(' * '//TRIM(knam)//'='//TRIM(v2)//' ; previous value kept:'//TRIM(v1), modname)
       END DO
@@ -879,5 +925,5 @@
 LOGICAL FUNCTION cumulTracers(sections, tr, lRename) RESULT(lerr)
   TYPE(dataBase_type),  TARGET, INTENT(IN)  :: sections(:)
-  TYPE(keys_type), ALLOCATABLE, INTENT(OUT) ::       tr(:)
+  TYPE(trac_type), ALLOCATABLE, INTENT(OUT) ::       tr(:)
   LOGICAL,            OPTIONAL, INTENT(IN)  :: lRename               !--- .TRUE.: add a section suffix to identical names
   CHARACTER(LEN=maxlen)  :: tnam_new, modname
@@ -888,16 +934,18 @@
   tr = [( sections(is)%trac(:), is = 1, SIZE(sections) )]            !--- Concatenated tracers vector
   IF(PRESENT(lRename)) THEN; IF(lRename) RETURN; END IF              !--- No renaming: finished
-  lerr = getKey('name',     tname, tr); IF(lerr) RETURN              !--- Names
-  lerr = getKey('parent',  parent, tr); IF(lerr) RETURN              !--- Parents
-  lerr = getKey('component', comp, tr); IF(lerr) RETURN              !--- Component name
+  lerr = getKey('name',     tname, tr%keys); IF(lerr) RETURN         !--- Names
+  lerr = getKey('parent',  parent, tr%keys); IF(lerr) RETURN         !--- Parents
+  lerr = getKey('component', comp, tr%keys); IF(lerr) RETURN         !--- Component name
   !----------------------------------------------------------------------------------------------------------------------------
   DO iq = 1, SIZE(tr); IF(COUNT(tname == tname(iq)) == 1) CYCLE      !=== LOOP ON TRACERS
   !----------------------------------------------------------------------------------------------------------------------------
     tnam_new = TRIM(tname(iq))//'_'//TRIM(comp(iq))                  !--- Same with section extension
-    CALL addKey('name', tnam_new, tr(iq))                            !--- Modify tracer name
+    CALL addKey('name', tnam_new, tr(iq)%keys)                       !--- Modify tracer name
+    tr(iq)%name = TRIM(tnam_new)                                     !--- Modify tracer name
     !--------------------------------------------------------------------------------------------------------------------------
     DO jq = 1, SIZE(tr); IF(parent(jq) /= tname(iq)) CYCLE           !=== LOOP ON TRACERS PARENTS
     !--------------------------------------------------------------------------------------------------------------------------
-      CALL addKey('parent', tnam_new, tr(jq))                        !--- Modify tracer name
+      CALL addKey('parent', tnam_new, tr(jq)%keys)                   !--- Modify tracer name
+      tr(jq)%parent = TRIM(tnam_new)                                 !--- Modify tracer name
     !--------------------------------------------------------------------------------------------------------------------------
     END DO
@@ -946,5 +994,5 @@
     tmp = int2str([(iq, iq=1, nq)])
   ELSE
-    lerr = getKey(nam, tmp, dBase(idb)%trac(:), lDisp=lMandatory)
+    lerr = getKey(nam, tmp, dBase(idb)%trac(:)%keys, lDisp=lMandatory)
   END IF
   IF(lerr) THEN; lerr = lMandatory; RETURN; END IF
@@ -965,10 +1013,10 @@
 LOGICAL FUNCTION aliasTracer(tname, trac, alias) RESULT(lerr)                  !=== TRACER NAMED "tname" - SCALAR
   CHARACTER(LEN=*),         INTENT(IN)  :: tname
-  TYPE(keys_type), TARGET,  INTENT(IN)  :: trac(:)
-  TYPE(keys_type), POINTER, INTENT(OUT) :: alias
+  TYPE(trac_type), TARGET,  INTENT(IN)  :: trac(:)
+  TYPE(trac_type), POINTER, INTENT(OUT) :: alias
   INTEGER :: it
   CHARACTER(LEN=maxlen), ALLOCATABLE :: tnames(:)
   alias => NULL()
-  lerr = getKey('name', tnames, trac(:))
+  lerr = getKey('name', tnames, trac(:)%keys)
   it = strIdx(tnames, tname)
   lerr = it /= 0; IF(.NOT.lerr) alias => trac(it)
@@ -976,7 +1024,7 @@
 !==============================================================================================================================
 LOGICAL FUNCTION trSubset_Indx(trac, idx, alias) RESULT(lerr)                  !=== TRACERS WITH INDICES "idx(:)" - VECTOR
-  TYPE(keys_type), ALLOCATABLE, INTENT(IN)  ::  trac(:)
+  TYPE(trac_type), ALLOCATABLE, INTENT(IN)  ::  trac(:)
   INTEGER,                      INTENT(IN)  ::   idx(:)
-  TYPE(keys_type), ALLOCATABLE, INTENT(OUT) :: alias(:)
+  TYPE(trac_type), ALLOCATABLE, INTENT(OUT) :: alias(:)
   alias = trac(idx)
   lerr = indexUpdate(alias)
@@ -984,9 +1032,9 @@
 !------------------------------------------------------------------------------------------------------------------------------
 LOGICAL FUNCTION trSubset_Name(trac, tname, alias) RESULT(lerr)                !=== TRACERS NAMED "tname(:)" - VECTOR
-  TYPE(keys_type), ALLOCATABLE, INTENT(IN)  ::  trac(:)
+  TYPE(trac_type), ALLOCATABLE, INTENT(IN)  ::  trac(:)
   CHARACTER(LEN=*),             INTENT(IN)  :: tname(:)
-  TYPE(keys_type), ALLOCATABLE, INTENT(OUT) :: alias(:)
+  TYPE(trac_type), ALLOCATABLE, INTENT(OUT) :: alias(:)
   CHARACTER(LEN=maxlen), ALLOCATABLE :: tnames(:)
-  lerr = getKey('name', tnames, trac(:))
+  lerr = getKey('name', tnames, trac(:)%keys)
   alias = trac(strIdx(tnames, tname))
   lerr = indexUpdate(alias)
@@ -994,9 +1042,9 @@
 !==============================================================================================================================
 LOGICAL FUNCTION trSubset_gen0Name(trac, gen0Nm, alias) RESULT(lerr)           !=== TRACERS OF COMMON 1st GENERATION ANCESTOR
-  TYPE(keys_type), ALLOCATABLE, INTENT(IN)  :: trac(:)
+  TYPE(trac_type), ALLOCATABLE, INTENT(IN)  :: trac(:)
   CHARACTER(LEN=*),             INTENT(IN)  :: gen0Nm
-  TYPE(keys_type), ALLOCATABLE, INTENT(OUT) :: alias(:)
+  TYPE(trac_type), ALLOCATABLE, INTENT(OUT) :: alias(:)
   CHARACTER(LEN=maxlen), ALLOCATABLE :: gen0N(:)
-  lerr = getKey('gen0Name', gen0N, trac(:))
+  lerr = getKey('gen0Name', gen0N, trac(:)%keys)
   alias = trac(strFind(delPhase(gen0N), gen0Nm))
   lerr = indexUpdate(alias)
@@ -1006,21 +1054,22 @@
 
 !==============================================================================================================================
-!=== UPDATE THE INDEXES iqParent, iqDescen, nqDescen, nqChildren IN THE TRACERS DESCRIPTOR LIST "tr" ==========================
+!=== UPDATE THE INDEXES iqParent, iqDescend AND iGeneration IN THE TRACERS DESCRIPTOR LIST "tr" (USEFULL FOR SUBSETS) =========
 !==============================================================================================================================
 LOGICAL FUNCTION indexUpdate(tr) RESULT(lerr)
-  TYPE(keys_type), INTENT(INOUT) :: tr(:)
+  TYPE(trac_type), INTENT(INOUT) :: tr(:)
   INTEGER :: iq, jq, nq, ig, nGen
   INTEGER,               ALLOCATABLE :: iqDescen(:), ix(:), iy(:)
   CHARACTER(LEN=maxlen), ALLOCATABLE :: tnames(:), parent(:)
   INTEGER,       DIMENSION(SIZE(tr)) :: iqParent, iGen
-  lerr = getKey('name',   tnames, tr); IF(lerr) RETURN               !--- Names
-  lerr = getKey('parent', parent, tr); IF(lerr) RETURN               !--- Parents
+  lerr = getKey('name',   tnames, tr%keys); IF(lerr) RETURN          !--- Names
+  lerr = getKey('parent', parent, tr%keys); IF(lerr) RETURN          !--- Parents
   nq = SIZE(tr)
 
-  !=== iqParent
+  !=== iqParent, iGeneration
   DO iq = 1, nq; iGen(iq) = 0; jq = iq
     iqParent(iq) = strIdx(tnames, parent(iq))
     DO; jq = strIdx(tnames, parent(jq)); IF(jq == 0) EXIT; iGen(iq) = iGen(iq) + 1; END DO
-    CALL addKey('iqParent', iqParent(iq), tr(iq))
+    CALL addKey('iqParent',   parent(iq), tr(iq)%keys)
+    CALL addKey('iqGeneration', iGen(iq), tr(iq)%keys)
   END DO
 
@@ -1029,12 +1078,14 @@
   DO iq = 1, nq
     ix = [iq]; ALLOCATE(iqDescen(0))
-    CALL addKey('nqChildren', 0, tr(iq))
     DO ig = iGen(iq)+1, nGen
       iy = find(iqParent, ix); iqDescen = [iqDescen, iy]; ix = iy
       IF(ig /= iGen(iq)+1) CYCLE
-      CALL addKey('nqChildren', SIZE(iqDescen), tr(iq))
+      CALL addKey('nqChildren', SIZE(iqDescen), tr(iq)%keys)
+      tr(iq)%nqChildren = SIZE(iqDescen)
     END DO
-    CALL addKey('iqDescen', strStack(int2str(iqDescen)), tr(iq))
-    CALL addKey('nqDescen',             SIZE(iqDescen),  tr(iq))
+    CALL addKey('iqDescen', strStack(int2str(iqDescen)), tr(iq)%keys)
+    CALL addKey('nqDescen',             SIZE(iqDescen),  tr(iq)%keys)
+    tr(iq)%iqDescen =      iqDescen
+    tr(iq)%nqDescen = SIZE(iqDescen)
     DEALLOCATE(iqDescen)
   END DO
@@ -1044,10 +1095,10 @@
   
 !==============================================================================================================================
-!=== READ FILE "fnam" TO APPEND THE "dBase" TRACERS DATABASE WITH AS MUCH SECTIONS AS ISOTOPES CLASSES IN "isot(:)%name":  ====
-!===  * Each section dBase(i)%name contains the isotopes "dBase(i)%trac(:)" descending on "dBase(i)%name"="iso(i)%name"    ====
+!=== READ FILE "fnam" TO APPEND THE "dBase" TRACERS DATABASE WITH AS MUCH SECTIONS AS PARENTS NAMES IN "isot(:)%parent":   ====
+!===  * Each section dBase(i)%name contains the isotopes "dBase(i)%trac(:)" descending on "dBase(i)%name"="iso(i)%parent"  ====
 !===  * For each isotopes class, the <key>=<val> vector of each tracer is moved into the isotopes descriptor "isot"        ====
 !=== NOTES:                                                                                                                ====
 !===  * Most of the "isot" components have been defined in the calling routine (processIsotopes):                          ====
-!===      name,  nzone, zone(:),  niso, keys(:)%name,  ntiso, trac(:),  nphas, phas,  iqIsoPha(:,:),  itZonPhi(:,:)        ====
+!===      parent,  nzone, zone(:),  niso, keys(:)%name,  ntiso, trac(:),  nphas, phas,  iqIsoPha(:,:),  itZonPhi(:,:)      ====
 !===  * Same syntax for isotopes file and "tracer.def": a tracers section contains one line for each of its isotopes       ====
 !===  * Each tracers section can contain a "params" virtual isotope line of isotopes parameters default values             ====
@@ -1058,22 +1109,20 @@
 LOGICAL FUNCTION readIsotopesFile(fnam, isot) RESULT(lerr)
   CHARACTER(LEN=*),        INTENT(IN)    :: fnam                     !--- Input file name
-  TYPE(isot_type), TARGET, INTENT(INOUT) :: isot(:)                  !--- Isotopes descriptors (field %name must be defined!)
+  TYPE(isot_type), TARGET, INTENT(INOUT) :: isot(:)                  !--- Isotopes descriptors (field %parent must be defined!)
   LOGICAL :: lFound
   INTEGER :: is, iis, it, idb, ndb, nb0
-  CHARACTER(LEN=maxlen), ALLOCATABLE :: vals(:), tname(:), iname(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: vals(:)
   CHARACTER(LEN=maxlen)              :: modname
-  TYPE(keys_type),           POINTER ::   t
+  TYPE(trac_type),           POINTER ::   tt(:), t
   TYPE(dataBase_type),   ALLOCATABLE ::  tdb(:)
   modname = 'readIsotopesFile'
 
   !--- THE INPUT FILE MUST BE PRESENT
-  INQUIRE(FILE=TRIM(fnam), EXIST=lFound)
-  lerr = .NOT.lFound
-  CALL msg('Missing isotopes parameters file "'//TRIM(fnam)//'"', modname, lerr)
-  IF(lerr) RETURN
-
-  !--- READ THE FILE SECTIONS, ONE EACH ISOTOPES CLASS (FIEDL %name)
+  INQUIRE(FILE=TRIM(fnam), EXIST=lFound); lerr = .NOT.lFound
+  IF(fmsg('Missing isotopes parameters file "'//TRIM(fnam)//'"', modname, lerr)) RETURN
+
+  !--- READ THE FILE SECTIONS, ONE EACH PARENT TRACER
   nb0 = SIZE(dBase, DIM=1)+1                                         !--- Next database element index
-  lerr = readSections(fnam,strStack(isot(:)%name,'|')); IF(lerr) RETURN !--- Read sections, one each isotopes class %name
+  lerr = readSections(fnam,strStack(isot(:)%parent,'|')); IF(lerr) RETURN !--- Read sections, one each parent tracer
   ndb = SIZE(dBase, DIM=1)                                           !--- Current database size
   DO idb = nb0, ndb
@@ -1081,23 +1130,23 @@
 
     !--- GET FEW GLOBAL KEYS FROM "def" FILES AND ADD THEM TO THE 'params' SECTION
-!    lerr = addKeysFromDef(dBase(idb)%trac, 'params');     IF(lerr) RETURN
+    CALL addKeysFromDef(dBase(idb)%trac, 'params')
 
     !--- SUBSTITUTE THE KEYS DEFINED IN THE 'params' VIRTUAL TRACER ; SUBSTITUTE LOCAL KEYS ; REMOVE 'params' VIRTUAL TRACER
-    lerr = subDefault(dBase(idb)%trac, 'params', .TRUE.); IF(lerr) RETURN
+    CALL subDefault(dBase(idb)%trac, 'params', .TRUE.)
+
+    tt => dBase(idb)%trac
 
     !--- REDUCE THE EXPRESSIONS TO OBTAIN SCALARS AND TRANSFER THEM TO THE "isot" ISOTOPES DESCRIPTORS VECTOR
-    lerr = getKey('name', tname, dBase(idb)%trac);        IF(lerr) RETURN
-    lerr = getKey('name', iname, isot(iis)%keys);         IF(lerr) RETURN
     DO it = 1, SIZE(dBase(idb)%trac)
       t => dBase(idb)%trac(it)
-      is = strIdx(iname, tname(it))                                  !--- Index in "iname(:)" of isotope "tname(it)"
+      is = strIdx(isot(iis)%keys(:)%name, t%name)                    !--- Index in "isot(iis)%keys(:)%name" of isotope "t%name"
       IF(is == 0) CYCLE
-      lerr = ANY(reduceExpr(t%val, vals)); IF(lerr) RETURN           !--- Reduce expressions ; detect non-numerical elements
-      isot(iis)%keys(is)%key = t%key
+      lerr = ANY(reduceExpr(t%keys%val, vals)); IF(lerr) RETURN      !--- Reduce expressions ; detect non-numerical elements
+      isot(iis)%keys(is)%key = t%keys%key
       isot(iis)%keys(is)%val = vals
     END DO
 
     !--- CHECK FOR MISSING ISOTOPES (NO KEYS ALLOCATED)
-    lerr = checkList(iname, .NOT.[( ALLOCATED(isot(iis)%keys(is)%key), is=1, SIZE(isot(iis)%keys) )], &
+    lerr = checkList(isot(iis)%keys(:)%name, .NOT.[( ALLOCATED(isot(iis)%keys(is)%key), is=1, SIZE(isot(iis)%keys) )], &
                      'Check file "'//TRIM(fnam)//'" in section "'//TRIM(dBase(idb)%name)//'"', 'isotopes', 'missing')
     IF(lerr) RETURN
@@ -1112,5 +1161,5 @@
 
   !--- GET THE isoCheck ENTRY FROM THE *.DEF FILES (MIGHT BE CHANGED TO A CLASS-DEPENDANT KEYWORD)
-  CALL get_in('ok_iso_verif', isot(strIdx(iname, 'H2O'))%check, .FALSE.)
+  CALL get_in('ok_iso_verif', isot(strIdx(isot%parent, 'H2O'))%check, .FALSE.)
 
   lerr = dispIsotopes()
@@ -1122,8 +1171,7 @@
   INTEGER :: ik, nk, ip, it, nt
   CHARACTER(LEN=maxlen) :: prf
-  CHARACTER(LEN=maxlen), ALLOCATABLE :: ttl(:), val(:,:), tname(:)
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: ttl(:), val(:,:)
   CALL msg('Isotopes parameters read from file "'//TRIM(fnam)//'":', modname)
-  DO ip = 1, SIZE(isot)                                              !--- Loop on isotopes classes
-    IF(SIZE(isot(ip)%keys) == 0) CYCLE
+  DO ip = 1, SIZE(isot)                                              !--- Loop on parents tracers
     nk = SIZE(isot(ip)%keys(1)%key)                                  !--- Same keys for each isotope
     nt = SIZE(isot(ip)%keys)                                         !--- Number of isotopes
@@ -1131,6 +1179,5 @@
     ALLOCATE(ttl(nk+2), val(nt,nk+1))
     ttl(1:2) = ['it  ','name']; ttl(3:nk+2) = isot(ip)%keys(1)%key(:)!--- Titles line with keys names
-    lerr = getKey('name', tname, isot(ip)%keys); IF(lerr) RETURN
-    val(:,1) = tname                                                 !--- Values table 1st column: isotopes names
+    val(:,1) = isot(ip)%keys(:)%name                                 !--- Values table 1st column: isotopes names  
     DO ik = 1, nk
       DO it = 1, nt
